/*  ==========================================================================
    Images
    ========================================================================== */

/*
    Block
    ========================================================================== */

.image {

}

/*
    Modifiers
    ========================================================================== */

.image--full {

    img {
        width: 100%;
        display: block;
    }
}

/*  ==========================================================================
    Lazyload Images
    ========================================================================== */

/*
    Block
    ========================================================================== */

.intrinsic-image {
    position: relative;
    background: map-get( $c-colours, off-white );
    transform: translate3d(0, 0, 0);
    backface-visibility: hidden;

    &.image--bg-transparent {
        background: transparent;
    }

    img {
        position: absolute;
        top: 0;
        left: 0;
        display: block;
        width: 100%;
        height: auto;
        opacity: 0;
        transition: opacity ease 150ms;
        backface-visibility: hidden;
    }
}

.lazy_image {
    overflow: hidden;
    position: relative;
    padding-bottom: 67%;
    transform: translate3d(0, 0, 0);
    backface-visibility: hidden;

    img {
        position: absolute;
        top: 0;
        right: 0;
        bottom: 0;
        left: 0;
        width: 100%;
        opacity: 0;
        backface-visibility: hidden;
        transition: opacity ease 150ms;
        transform: translate3d(0, 0, 0);
        backface-visibility: hidden;
    }
}

img {

    &.lazyloading,
    &.lazyload {
        opacity: 0;
    }

    &.lazyloaded {
        animation: fade 150ms forwards;
    }
}

@keyframes fade {

    0% {
        opacity: 0;
    }

    100% {
        opacity: 1;
    }
}

@mixin instrinsic-cover($height) {
  .intrinsic-image {
        position: absolute;
        top: auto;
        left: 0;
        width: 100%;
        height: $height;
        padding: 0 !important;

        img {
            position: relative;
            width: 100%;
            height: 100%;
            top: auto;
            right: auto;
            bottom: auto;
            left: auto;
            object-fit: cover;
            font-family: "object-fit: cover";
        }
    }
}

@mixin instrinsic-contain($height) {
  .intrinsic-image {
        position: absolute;
        top: auto;
        left: 0;
        width: 100%;
        height: $height;
        padding: 0 !important;

        img {
            position: relative;
            width: 100%;
            height: 100%;
            top: auto;
            right: auto;
            bottom: auto;
            left: auto;
            object-fit: contain;
            font-family: "object-fit: contain";
        }
    }
}

.image--size-cover {
    $height: 100%;
    position: relative;
    width: 100%;
    height: $height;
    @include instrinsic-cover($height);
}

.image--size-contain {
    $height: 420px;
    position: relative;
    width: 100%;
    height: $height;
    @include instrinsic-contain($height);
}